Browse Source

Initial commit of Zsh Navigation Tools

Sebastian Gniazdowski 8 years ago
parent
commit
4c292ea2b0
28 changed files with 2273 additions and 0 deletions
  1. 1 0
      plugins/zsh-navigation-tools/.config/znt/README.txt
  2. 5 0
      plugins/zsh-navigation-tools/.config/znt/n-aliases.conf
  3. 25 0
      plugins/zsh-navigation-tools/.config/znt/n-cd.conf
  4. 9 0
      plugins/zsh-navigation-tools/.config/znt/n-env.conf
  5. 10 0
      plugins/zsh-navigation-tools/.config/znt/n-functions.conf
  6. 5 0
      plugins/zsh-navigation-tools/.config/znt/n-history.conf
  7. 13 0
      plugins/zsh-navigation-tools/.config/znt/n-kill.conf
  8. 3 0
      plugins/zsh-navigation-tools/.config/znt/n-list.conf
  9. 5 0
      plugins/zsh-navigation-tools/.config/znt/n-options.conf
  10. 5 0
      plugins/zsh-navigation-tools/.config/znt/n-panelize.conf
  11. 700 0
      plugins/zsh-navigation-tools/LICENSE
  12. 101 0
      plugins/zsh-navigation-tools/README.txt
  13. 47 0
      plugins/zsh-navigation-tools/n-aliases
  14. 68 0
      plugins/zsh-navigation-tools/n-cd
  15. 47 0
      plugins/zsh-navigation-tools/n-env
  16. 54 0
      plugins/zsh-navigation-tools/n-functions
  17. 53 0
      plugins/zsh-navigation-tools/n-history
  18. 96 0
      plugins/zsh-navigation-tools/n-kill
  19. 410 0
      plugins/zsh-navigation-tools/n-list
  20. 131 0
      plugins/zsh-navigation-tools/n-list-draw
  21. 238 0
      plugins/zsh-navigation-tools/n-list-input
  22. 84 0
      plugins/zsh-navigation-tools/n-options
  23. 61 0
      plugins/zsh-navigation-tools/n-panelize
  24. 8 0
      plugins/zsh-navigation-tools/znt-cd-widget
  25. 8 0
      plugins/zsh-navigation-tools/znt-history-widget
  26. 8 0
      plugins/zsh-navigation-tools/znt-kill-widget
  27. 40 0
      plugins/zsh-navigation-tools/znt-usetty-wrapper
  28. 38 0
      plugins/zsh-navigation-tools/zsh-navigation-tools.plugin.zsh

+ 1 - 0
plugins/zsh-navigation-tools/.config/znt/README.txt

@@ -0,0 +1 @@
+These are skeletons, configuration is read from ~/.config/znt/*

+ 5 - 0
plugins/zsh-navigation-tools/.config/znt/n-aliases.conf

@@ -0,0 +1,5 @@
+# How should be current element of the list drawn. Possible values: reverse,
+# underline. Default (without option set) is reverse
+# On Linux virtual terminal this will be enforced to reverse (because of poor
+# underline support on that terminal)
+# local active_text=underline

+ 25 - 0
plugins/zsh-navigation-tools/.config/znt/n-cd.conf

@@ -0,0 +1,25 @@
+# Hotlist
+local hotlist
+hotlist=(
+    /usr/share/zsh/site-functions
+    /usr/share/zsh
+    /usr/local/share/zsh/site-functions
+    /usr/local/share/zsh
+    /usr/local/bin
+    /usr/lib
+)
+
+# Suppress adding (to directory stack) directories visited by n-cd
+# Value 0 is the default (directories will be added to dirstack)
+local NCD_DONT_PUSHD=0
+
+# How should be current element of the list drawn. Possible values: reverse,
+# underline. Default (without option set) is reverse
+# On Linux virtual terminal this will be enforced to reverse (because of poor
+# underline support on that terminal)
+# local active_text=underline
+
+# Colorize last segments of the paths
+# (#s) is ^, (#e) is $, # is *, ## is + (comparing to regex)
+local NLIST_COLORING_PATTERN="[a-zA-Z0-9 ._-]##/#(#e)"
+local NLIST_COLORING_COLOR=$'\x1b[00;33m'

+ 9 - 0
plugins/zsh-navigation-tools/.config/znt/n-env.conf

@@ -0,0 +1,9 @@
+# How should be current element of the list drawn. Possible values: reverse,
+# underline. Default (without option set) is reverse
+# On Linux virtual terminal this will be enforced to reverse (because of poor
+# underline support on that terminal)
+# local active_text=underline
+
+# (#s) is ^, (#e) is $, # is *, ## is + (comparing to regex)
+local NLIST_COLORING_PATTERN="[a-zA-Z0-9_]##"
+local NLIST_COLORING_MATCH_MULTIPLE=0

+ 10 - 0
plugins/zsh-navigation-tools/.config/znt/n-functions.conf

@@ -0,0 +1,10 @@
+# Which editor to use, zed or vared
+# vared is the default
+local feditor="zed"
+# local feditor="vared"
+
+# How should be current element of the list drawn. Possible values: reverse,
+# underline. Default (without option set) is reverse
+# On Linux virtual terminal this will be enforced to reverse (because of poor
+# underline support on that terminal)
+# local active_text=underline

+ 5 - 0
plugins/zsh-navigation-tools/.config/znt/n-history.conf

@@ -0,0 +1,5 @@
+# How should be current element of the list drawn. Possible values: reverse,
+# underline. Default (without option set) is reverse
+# On Linux virtual terminal this will be enforced to reverse (because of poor
+# underline support on that terminal)
+local active_text=underline

+ 13 - 0
plugins/zsh-navigation-tools/.config/znt/n-kill.conf

@@ -0,0 +1,13 @@
+# How should be current element of the list drawn. Possible values: reverse,
+# underline. Default (without option set) is reverse
+# On Linux virtual terminal this will be enforced to reverse (because of poor
+# underline support on that terminal)
+# local active_text=underline
+
+# Colorize first number column and last path segment
+# This doesn't cover scripts named "[0-9]## *", which should be very rare
+# (#s) is ^, (#e) is $, # is *, ## is + (comparing to regex)
+# | is alternative, but only in ()
+local NLIST_COLORING_PATTERN="((#s) #[0-9]## |[[][^]]#](#e)|[^ 0-9/?\\\\][^/\\\\]#(#e)|[^ /\\\\]##[^0-9/\\\\ ]##[^/\\\\]#(#e))"
+local NLIST_COLORING_COLOR=$'\x1b[00;33m'
+local NLIST_COLORING_MATCH_MULTIPLE=1

+ 3 - 0
plugins/zsh-navigation-tools/.config/znt/n-list.conf

@@ -0,0 +1,3 @@
+# Should the list (text, borders) be drawn in bold
+# Value 1 is the default
+local bold=1

+ 5 - 0
plugins/zsh-navigation-tools/.config/znt/n-options.conf

@@ -0,0 +1,5 @@
+# How should be current element of the list drawn. Possible values: reverse,
+# underline. Default (without option set) is reverse
+# On Linux virtual terminal this will be enforced to reverse (because of poor
+# underline support on that terminal)
+# local active_text=underline

+ 5 - 0
plugins/zsh-navigation-tools/.config/znt/n-panelize.conf

@@ -0,0 +1,5 @@
+# How should be current element of the list drawn. Possible values: reverse,
+# underline. Default (without option set) is reverse
+# On Linux virtual terminal this will be enforced to reverse (because of poor
+# underline support on that terminal)
+# local active_text=underline

+ 700 - 0
plugins/zsh-navigation-tools/LICENSE

@@ -0,0 +1,700 @@
+This software is dual-licensed under MIT and GPLv3.
+
+MIT License
+-----------
+
+Permission is hereby granted, free of charge, to any person obtaining a copy
+of this software and associated documentation files (the "Software"), to deal
+in the Software without restriction, including without limitation the rights
+to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+copies of the Software, and to permit persons to whom the Software is
+furnished to do so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in
+all copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+THE SOFTWARE.
+
+GPLv3  License
+--------------
+
+                    GNU GENERAL PUBLIC LICENSE
+                       Version 3, 29 June 2007
+
+ Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+                            Preamble
+
+  The GNU General Public License is a free, copyleft license for
+software and other kinds of works.
+
+  The licenses for most software and other practical works are designed
+to take away your freedom to share and change the works.  By contrast,
+the GNU General Public License is intended to guarantee your freedom to
+share and change all versions of a program--to make sure it remains free
+software for all its users.  We, the Free Software Foundation, use the
+GNU General Public License for most of our software; it applies also to
+any other work released this way by its authors.  You can apply it to
+your programs, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+them if you wish), that you receive source code or can get it if you
+want it, that you can change the software or use pieces of it in new
+free programs, and that you know you can do these things.
+
+  To protect your rights, we need to prevent others from denying you
+these rights or asking you to surrender the rights.  Therefore, you have
+certain responsibilities if you distribute copies of the software, or if
+you modify it: responsibilities to respect the freedom of others.
+
+  For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must pass on to the recipients the same
+freedoms that you received.  You must make sure that they, too, receive
+or can get the source code.  And you must show them these terms so they
+know their rights.
+
+  Developers that use the GNU GPL protect your rights with two steps:
+(1) assert copyright on the software, and (2) offer you this License
+giving you legal permission to copy, distribute and/or modify it.
+
+  For the developers' and authors' protection, the GPL clearly explains
+that there is no warranty for this free software.  For both users' and
+authors' sake, the GPL requires that modified versions be marked as
+changed, so that their problems will not be attributed erroneously to
+authors of previous versions.
+
+  Some devices are designed to deny users access to install or run
+modified versions of the software inside them, although the manufacturer
+can do so.  This is fundamentally incompatible with the aim of
+protecting users' freedom to change the software.  The systematic
+pattern of such abuse occurs in the area of products for individuals to
+use, which is precisely where it is most unacceptable.  Therefore, we
+have designed this version of the GPL to prohibit the practice for those
+products.  If such problems arise substantially in other domains, we
+stand ready to extend this provision to those domains in future versions
+of the GPL, as needed to protect the freedom of users.
+
+  Finally, every program is threatened constantly by software patents.
+States should not allow patents to restrict development and use of
+software on general-purpose computers, but in those that do, we wish to
+avoid the special danger that patents applied to a free program could
+make it effectively proprietary.  To prevent this, the GPL assures that
+patents cannot be used to render the program non-free.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.
+
+                       TERMS AND CONDITIONS
+
+  0. Definitions.
+
+  "This License" refers to version 3 of the GNU General Public License.
+
+  "Copyright" also means copyright-like laws that apply to other kinds of
+works, such as semiconductor masks.
+
+  "The Program" refers to any copyrightable work licensed under this
+License.  Each licensee is addressed as "you".  "Licensees" and
+"recipients" may be individuals or organizations.
+
+  To "modify" a work means to copy from or adapt all or part of the work
+in a fashion requiring copyright permission, other than the making of an
+exact copy.  The resulting work is called a "modified version" of the
+earlier work or a work "based on" the earlier work.
+
+  A "covered work" means either the unmodified Program or a work based
+on the Program.
+
+  To "propagate" a work means to do anything with it that, without
+permission, would make you directly or secondarily liable for
+infringement under applicable copyright law, except executing it on a
+computer or modifying a private copy.  Propagation includes copying,
+distribution (with or without modification), making available to the
+public, and in some countries other activities as well.
+
+  To "convey" a work means any kind of propagation that enables other
+parties to make or receive copies.  Mere interaction with a user through
+a computer network, with no transfer of a copy, is not conveying.
+
+  An interactive user interface displays "Appropriate Legal Notices"
+to the extent that it includes a convenient and prominently visible
+feature that (1) displays an appropriate copyright notice, and (2)
+tells the user that there is no warranty for the work (except to the
+extent that warranties are provided), that licensees may convey the
+work under this License, and how to view a copy of this License.  If
+the interface presents a list of user commands or options, such as a
+menu, a prominent item in the list meets this criterion.
+
+  1. Source Code.
+
+  The "source code" for a work means the preferred form of the work
+for making modifications to it.  "Object code" means any non-source
+form of a work.
+
+  A "Standard Interface" means an interface that either is an official
+standard defined by a recognized standards body, or, in the case of
+interfaces specified for a particular programming language, one that
+is widely used among developers working in that language.
+
+  The "System Libraries" of an executable work include anything, other
+than the work as a whole, that (a) is included in the normal form of
+packaging a Major Component, but which is not part of that Major
+Component, and (b) serves only to enable use of the work with that
+Major Component, or to implement a Standard Interface for which an
+implementation is available to the public in source code form.  A
+"Major Component", in this context, means a major essential component
+(kernel, window system, and so on) of the specific operating system
+(if any) on which the executable work runs, or a compiler used to
+produce the work, or an object code interpreter used to run it.
+
+  The "Corresponding Source" for a work in object code form means all
+the source code needed to generate, install, and (for an executable
+work) run the object code and to modify the work, including scripts to
+control those activities.  However, it does not include the work's
+System Libraries, or general-purpose tools or generally available free
+programs which are used unmodified in performing those activities but
+which are not part of the work.  For example, Corresponding Source
+includes interface definition files associated with source files for
+the work, and the source code for shared libraries and dynamically
+linked subprograms that the work is specifically designed to require,
+such as by intimate data communication or control flow between those
+subprograms and other parts of the work.
+
+  The Corresponding Source need not include anything that users
+can regenerate automatically from other parts of the Corresponding
+Source.
+
+  The Corresponding Source for a work in source code form is that
+same work.
+
+  2. Basic Permissions.
+
+  All rights granted under this License are granted for the term of
+copyright on the Program, and are irrevocable provided the stated
+conditions are met.  This License explicitly affirms your unlimited
+permission to run the unmodified Program.  The output from running a
+covered work is covered by this License only if the output, given its
+content, constitutes a covered work.  This License acknowledges your
+rights of fair use or other equivalent, as provided by copyright law.
+
+  You may make, run and propagate covered works that you do not
+convey, without conditions so long as your license otherwise remains
+in force.  You may convey covered works to others for the sole purpose
+of having them make modifications exclusively for you, or provide you
+with facilities for running those works, provided that you comply with
+the terms of this License in conveying all material for which you do
+not control copyright.  Those thus making or running the covered works
+for you must do so exclusively on your behalf, under your direction
+and control, on terms that prohibit them from making any copies of
+your copyrighted material outside their relationship with you.
+
+  Conveying under any other circumstances is permitted solely under
+the conditions stated below.  Sublicensing is not allowed; section 10
+makes it unnecessary.
+
+  3. Protecting Users' Legal Rights From Anti-Circumvention Law.
+
+  No covered work shall be deemed part of an effective technological
+measure under any applicable law fulfilling obligations under article
+11 of the WIPO copyright treaty adopted on 20 December 1996, or
+similar laws prohibiting or restricting circumvention of such
+measures.
+
+  When you convey a covered work, you waive any legal power to forbid
+circumvention of technological measures to the extent such circumvention
+is effected by exercising rights under this License with respect to
+the covered work, and you disclaim any intention to limit operation or
+modification of the work as a means of enforcing, against the work's
+users, your or third parties' legal rights to forbid circumvention of
+technological measures.
+
+  4. Conveying Verbatim Copies.
+
+  You may convey verbatim copies of the Program's source code as you
+receive it, in any medium, provided that you conspicuously and
+appropriately publish on each copy an appropriate copyright notice;
+keep intact all notices stating that this License and any
+non-permissive terms added in accord with section 7 apply to the code;
+keep intact all notices of the absence of any warranty; and give all
+recipients a copy of this License along with the Program.
+
+  You may charge any price or no price for each copy that you convey,
+and you may offer support or warranty protection for a fee.
+
+  5. Conveying Modified Source Versions.
+
+  You may convey a work based on the Program, or the modifications to
+produce it from the Program, in the form of source code under the
+terms of section 4, provided that you also meet all of these conditions:
+
+    a) The work must carry prominent notices stating that you modified
+    it, and giving a relevant date.
+
+    b) The work must carry prominent notices stating that it is
+    released under this License and any conditions added under section
+    7.  This requirement modifies the requirement in section 4 to
+    "keep intact all notices".
+
+    c) You must license the entire work, as a whole, under this
+    License to anyone who comes into possession of a copy.  This
+    License will therefore apply, along with any applicable section 7
+    additional terms, to the whole of the work, and all its parts,
+    regardless of how they are packaged.  This License gives no
+    permission to license the work in any other way, but it does not
+    invalidate such permission if you have separately received it.
+
+    d) If the work has interactive user interfaces, each must display
+    Appropriate Legal Notices; however, if the Program has interactive
+    interfaces that do not display Appropriate Legal Notices, your
+    work need not make them do so.
+
+  A compilation of a covered work with other separate and independent
+works, which are not by their nature extensions of the covered work,
+and which are not combined with it such as to form a larger program,
+in or on a volume of a storage or distribution medium, is called an
+"aggregate" if the compilation and its resulting copyright are not
+used to limit the access or legal rights of the compilation's users
+beyond what the individual works permit.  Inclusion of a covered work
+in an aggregate does not cause this License to apply to the other
+parts of the aggregate.
+
+  6. Conveying Non-Source Forms.
+
+  You may convey a covered work in object code form under the terms
+of sections 4 and 5, provided that you also convey the
+machine-readable Corresponding Source under the terms of this License,
+in one of these ways:
+
+    a) Convey the object code in, or embodied in, a physical product
+    (including a physical distribution medium), accompanied by the
+    Corresponding Source fixed on a durable physical medium
+    customarily used for software interchange.
+
+    b) Convey the object code in, or embodied in, a physical product
+    (including a physical distribution medium), accompanied by a
+    written offer, valid for at least three years and valid for as
+    long as you offer spare parts or customer support for that product
+    model, to give anyone who possesses the object code either (1) a
+    copy of the Corresponding Source for all the software in the
+    product that is covered by this License, on a durable physical
+    medium customarily used for software interchange, for a price no
+    more than your reasonable cost of physically performing this
+    conveying of source, or (2) access to copy the
+    Corresponding Source from a network server at no charge.
+
+    c) Convey individual copies of the object code with a copy of the
+    written offer to provide the Corresponding Source.  This
+    alternative is allowed only occasionally and noncommercially, and
+    only if you received the object code with such an offer, in accord
+    with subsection 6b.
+
+    d) Convey the object code by offering access from a designated
+    place (gratis or for a charge), and offer equivalent access to the
+    Corresponding Source in the same way through the same place at no
+    further charge.  You need not require recipients to copy the
+    Corresponding Source along with the object code.  If the place to
+    copy the object code is a network server, the Corresponding Source
+    may be on a different server (operated by you or a third party)
+    that supports equivalent copying facilities, provided you maintain
+    clear directions next to the object code saying where to find the
+    Corresponding Source.  Regardless of what server hosts the
+    Corresponding Source, you remain obligated to ensure that it is
+    available for as long as needed to satisfy these requirements.
+
+    e) Convey the object code using peer-to-peer transmission, provided
+    you inform other peers where the object code and Corresponding
+    Source of the work are being offered to the general public at no
+    charge under subsection 6d.
+
+  A separable portion of the object code, whose source code is excluded
+from the Corresponding Source as a System Library, need not be
+included in conveying the object code work.
+
+  A "User Product" is either (1) a "consumer product", which means any
+tangible personal property which is normally used for personal, family,
+or household purposes, or (2) anything designed or sold for incorporation
+into a dwelling.  In determining whether a product is a consumer product,
+doubtful cases shall be resolved in favor of coverage.  For a particular
+product received by a particular user, "normally used" refers to a
+typical or common use of that class of product, regardless of the status
+of the particular user or of the way in which the particular user
+actually uses, or expects or is expected to use, the product.  A product
+is a consumer product regardless of whether the product has substantial
+commercial, industrial or non-consumer uses, unless such uses represent
+the only significant mode of use of the product.
+
+  "Installation Information" for a User Product means any methods,
+procedures, authorization keys, or other information required to install
+and execute modified versions of a covered work in that User Product from
+a modified version of its Corresponding Source.  The information must
+suffice to ensure that the continued functioning of the modified object
+code is in no case prevented or interfered with solely because
+modification has been made.
+
+  If you convey an object code work under this section in, or with, or
+specifically for use in, a User Product, and the conveying occurs as
+part of a transaction in which the right of possession and use of the
+User Product is transferred to the recipient in perpetuity or for a
+fixed term (regardless of how the transaction is characterized), the
+Corresponding Source conveyed under this section must be accompanied
+by the Installation Information.  But this requirement does not apply
+if neither you nor any third party retains the ability to install
+modified object code on the User Product (for example, the work has
+been installed in ROM).
+
+  The requirement to provide Installation Information does not include a
+requirement to continue to provide support service, warranty, or updates
+for a work that has been modified or installed by the recipient, or for
+the User Product in which it has been modified or installed.  Access to a
+network may be denied when the modification itself materially and
+adversely affects the operation of the network or violates the rules and
+protocols for communication across the network.
+
+  Corresponding Source conveyed, and Installation Information provided,
+in accord with this section must be in a format that is publicly
+documented (and with an implementation available to the public in
+source code form), and must require no special password or key for
+unpacking, reading or copying.
+
+  7. Additional Terms.
+
+  "Additional permissions" are terms that supplement the terms of this
+License by making exceptions from one or more of its conditions.
+Additional permissions that are applicable to the entire Program shall
+be treated as though they were included in this License, to the extent
+that they are valid under applicable law.  If additional permissions
+apply only to part of the Program, that part may be used separately
+under those permissions, but the entire Program remains governed by
+this License without regard to the additional permissions.
+
+  When you convey a copy of a covered work, you may at your option
+remove any additional permissions from that copy, or from any part of
+it.  (Additional permissions may be written to require their own
+removal in certain cases when you modify the work.)  You may place
+additional permissions on material, added by you to a covered work,
+for which you have or can give appropriate copyright permission.
+
+  Notwithstanding any other provision of this License, for material you
+add to a covered work, you may (if authorized by the copyright holders of
+that material) supplement the terms of this License with terms:
+
+    a) Disclaiming warranty or limiting liability differently from the
+    terms of sections 15 and 16 of this License; or
+
+    b) Requiring preservation of specified reasonable legal notices or
+    author attributions in that material or in the Appropriate Legal
+    Notices displayed by works containing it; or
+
+    c) Prohibiting misrepresentation of the origin of that material, or
+    requiring that modified versions of such material be marked in
+    reasonable ways as different from the original version; or
+
+    d) Limiting the use for publicity purposes of names of licensors or
+    authors of the material; or
+
+    e) Declining to grant rights under trademark law for use of some
+    trade names, trademarks, or service marks; or
+
+    f) Requiring indemnification of licensors and authors of that
+    material by anyone who conveys the material (or modified versions of
+    it) with contractual assumptions of liability to the recipient, for
+    any liability that these contractual assumptions directly impose on
+    those licensors and authors.
+
+  All other non-permissive additional terms are considered "further
+restrictions" within the meaning of section 10.  If the Program as you
+received it, or any part of it, contains a notice stating that it is
+governed by this License along with a term that is a further
+restriction, you may remove that term.  If a license document contains
+a further restriction but permits relicensing or conveying under this
+License, you may add to a covered work material governed by the terms
+of that license document, provided that the further restriction does
+not survive such relicensing or conveying.
+
+  If you add terms to a covered work in accord with this section, you
+must place, in the relevant source files, a statement of the
+additional terms that apply to those files, or a notice indicating
+where to find the applicable terms.
+
+  Additional terms, permissive or non-permissive, may be stated in the
+form of a separately written license, or stated as exceptions;
+the above requirements apply either way.
+
+  8. Termination.
+
+  You may not propagate or modify a covered work except as expressly
+provided under this License.  Any attempt otherwise to propagate or
+modify it is void, and will automatically terminate your rights under
+this License (including any patent licenses granted under the third
+paragraph of section 11).
+
+  However, if you cease all violation of this License, then your
+license from a particular copyright holder is reinstated (a)
+provisionally, unless and until the copyright holder explicitly and
+finally terminates your license, and (b) permanently, if the copyright
+holder fails to notify you of the violation by some reasonable means
+prior to 60 days after the cessation.
+
+  Moreover, your license from a particular copyright holder is
+reinstated permanently if the copyright holder notifies you of the
+violation by some reasonable means, this is the first time you have
+received notice of violation of this License (for any work) from that
+copyright holder, and you cure the violation prior to 30 days after
+your receipt of the notice.
+
+  Termination of your rights under this section does not terminate the
+licenses of parties who have received copies or rights from you under
+this License.  If your rights have been terminated and not permanently
+reinstated, you do not qualify to receive new licenses for the same
+material under section 10.
+
+  9. Acceptance Not Required for Having Copies.
+
+  You are not required to accept this License in order to receive or
+run a copy of the Program.  Ancillary propagation of a covered work
+occurring solely as a consequence of using peer-to-peer transmission
+to receive a copy likewise does not require acceptance.  However,
+nothing other than this License grants you permission to propagate or
+modify any covered work.  These actions infringe copyright if you do
+not accept this License.  Therefore, by modifying or propagating a
+covered work, you indicate your acceptance of this License to do so.
+
+  10. Automatic Licensing of Downstream Recipients.
+
+  Each time you convey a covered work, the recipient automatically
+receives a license from the original licensors, to run, modify and
+propagate that work, subject to this License.  You are not responsible
+for enforcing compliance by third parties with this License.
+
+  An "entity transaction" is a transaction transferring control of an
+organization, or substantially all assets of one, or subdividing an
+organization, or merging organizations.  If propagation of a covered
+work results from an entity transaction, each party to that
+transaction who receives a copy of the work also receives whatever
+licenses to the work the party's predecessor in interest had or could
+give under the previous paragraph, plus a right to possession of the
+Corresponding Source of the work from the predecessor in interest, if
+the predecessor has it or can get it with reasonable efforts.
+
+  You may not impose any further restrictions on the exercise of the
+rights granted or affirmed under this License.  For example, you may
+not impose a license fee, royalty, or other charge for exercise of
+rights granted under this License, and you may not initiate litigation
+(including a cross-claim or counterclaim in a lawsuit) alleging that
+any patent claim is infringed by making, using, selling, offering for
+sale, or importing the Program or any portion of it.
+
+  11. Patents.
+
+  A "contributor" is a copyright holder who authorizes use under this
+License of the Program or a work on which the Program is based.  The
+work thus licensed is called the contributor's "contributor version".
+
+  A contributor's "essential patent claims" are all patent claims
+owned or controlled by the contributor, whether already acquired or
+hereafter acquired, that would be infringed by some manner, permitted
+by this License, of making, using, or selling its contributor version,
+but do not include claims that would be infringed only as a
+consequence of further modification of the contributor version.  For
+purposes of this definition, "control" includes the right to grant
+patent sublicenses in a manner consistent with the requirements of
+this License.
+
+  Each contributor grants you a non-exclusive, worldwide, royalty-free
+patent license under the contributor's essential patent claims, to
+make, use, sell, offer for sale, import and otherwise run, modify and
+propagate the contents of its contributor version.
+
+  In the following three paragraphs, a "patent license" is any express
+agreement or commitment, however denominated, not to enforce a patent
+(such as an express permission to practice a patent or covenant not to
+sue for patent infringement).  To "grant" such a patent license to a
+party means to make such an agreement or commitment not to enforce a
+patent against the party.
+
+  If you convey a covered work, knowingly relying on a patent license,
+and the Corresponding Source of the work is not available for anyone
+to copy, free of charge and under the terms of this License, through a
+publicly available network server or other readily accessible means,
+then you must either (1) cause the Corresponding Source to be so
+available, or (2) arrange to deprive yourself of the benefit of the
+patent license for this particular work, or (3) arrange, in a manner
+consistent with the requirements of this License, to extend the patent
+license to downstream recipients.  "Knowingly relying" means you have
+actual knowledge that, but for the patent license, your conveying the
+covered work in a country, or your recipient's use of the covered work
+in a country, would infringe one or more identifiable patents in that
+country that you have reason to believe are valid.
+
+  If, pursuant to or in connection with a single transaction or
+arrangement, you convey, or propagate by procuring conveyance of, a
+covered work, and grant a patent license to some of the parties
+receiving the covered work authorizing them to use, propagate, modify
+or convey a specific copy of the covered work, then the patent license
+you grant is automatically extended to all recipients of the covered
+work and works based on it.
+
+  A patent license is "discriminatory" if it does not include within
+the scope of its coverage, prohibits the exercise of, or is
+conditioned on the non-exercise of one or more of the rights that are
+specifically granted under this License.  You may not convey a covered
+work if you are a party to an arrangement with a third party that is
+in the business of distributing software, under which you make payment
+to the third party based on the extent of your activity of conveying
+the work, and under which the third party grants, to any of the
+parties who would receive the covered work from you, a discriminatory
+patent license (a) in connection with copies of the covered work
+conveyed by you (or copies made from those copies), or (b) primarily
+for and in connection with specific products or compilations that
+contain the covered work, unless you entered into that arrangement,
+or that patent license was granted, prior to 28 March 2007.
+
+  Nothing in this License shall be construed as excluding or limiting
+any implied license or other defenses to infringement that may
+otherwise be available to you under applicable patent law.
+
+  12. No Surrender of Others' Freedom.
+
+  If conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot convey a
+covered work so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you may
+not convey it at all.  For example, if you agree to terms that obligate you
+to collect a royalty for further conveying from those to whom you convey
+the Program, the only way you could satisfy both those terms and this
+License would be to refrain entirely from conveying the Program.
+
+  13. Use with the GNU Affero General Public License.
+
+  Notwithstanding any other provision of this License, you have
+permission to link or combine any covered work with a work licensed
+under version 3 of the GNU Affero General Public License into a single
+combined work, and to convey the resulting work.  The terms of this
+License will continue to apply to the part which is the covered work,
+but the special requirements of the GNU Affero General Public License,
+section 13, concerning interaction through a network will apply to the
+combination as such.
+
+  14. Revised Versions of this License.
+
+  The Free Software Foundation may publish revised and/or new versions of
+the GNU General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+  Each version is given a distinguishing version number.  If the
+Program specifies that a certain numbered version of the GNU General
+Public License "or any later version" applies to it, you have the
+option of following the terms and conditions either of that numbered
+version or of any later version published by the Free Software
+Foundation.  If the Program does not specify a version number of the
+GNU General Public License, you may choose any version ever published
+by the Free Software Foundation.
+
+  If the Program specifies that a proxy can decide which future
+versions of the GNU General Public License can be used, that proxy's
+public statement of acceptance of a version permanently authorizes you
+to choose that version for the Program.
+
+  Later license versions may give you additional or different
+permissions.  However, no additional obligations are imposed on any
+author or copyright holder as a result of your choosing to follow a
+later version.
+
+  15. Disclaimer of Warranty.
+
+  THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
+APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
+HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
+OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
+THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
+IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
+ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+  16. Limitation of Liability.
+
+  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
+THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
+GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
+USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
+DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
+PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
+EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
+SUCH DAMAGES.
+
+  17. Interpretation of Sections 15 and 16.
+
+  If the disclaimer of warranty and limitation of liability provided
+above cannot be given local legal effect according to their terms,
+reviewing courts shall apply local law that most closely approximates
+an absolute waiver of all civil liability in connection with the
+Program, unless a warranty or assumption of liability accompanies a
+copy of the Program in return for a fee.
+
+                     END OF TERMS AND CONDITIONS
+
+            How to Apply These Terms to Your New Programs
+
+  If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+  To do so, attach the following notices to the program.  It is safest
+to attach them to the start of each source file to most effectively
+state the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the program's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This program is free software: you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+Also add information on how to contact you by electronic and paper mail.
+
+  If the program does terminal interaction, make it output a short
+notice like this when it starts in an interactive mode:
+
+    <program>  Copyright (C) <year>  <name of author>
+    This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+    This is free software, and you are welcome to redistribute it
+    under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License.  Of course, your program's commands
+might be different; for a GUI interface, you would use an "about box".
+
+  You should also get your employer (if you work as a programmer) or school,
+if any, to sign a "copyright disclaimer" for the program, if necessary.
+For more information on this, and how to apply and follow the GNU GPL, see
+<http://www.gnu.org/licenses/>.
+
+  The GNU General Public License does not permit incorporating your program
+into proprietary programs.  If your program is a subroutine library, you
+may consider it more useful to permit linking proprietary applications with
+the library.  If this is what you want to do, use the GNU Lesser General
+Public License instead of this License.  But first, please read
+<http://www.gnu.org/philosophy/why-not-lgpl.html>.

+ 101 - 0
plugins/zsh-navigation-tools/README.txt

@@ -0,0 +1,101 @@
+# Zsh Navigation Tools
+
+http://imageshack.com/a/img633/7967/ps6rKR.png
+
+A tool generating a selectable curses-based list of elements that has access to
+current Zsh session, i.e. has broad capabilities to work together with it.
+That's n-list. The files n-cd, n-env, n-kill, etc. are applications of
+the tool. Feature highlights include incremental multi-word searching, ANSI
+coloring, unique mode, horizontal scroll, non-selectable elements, grepping and
+various integrations with Zsh.
+
+## History Widget
+
+To have n-history as the incremental searcher bound to Ctrl-R copy znt-*
+files into the */site-functions dir (unless you use Oh My Zsh) and
+add:
+
+    autoload znt-history-widget
+    zle -N znt-history-widget
+    bindkey "^R" znt-history-widget
+
+to .zshrc. This is done automatically when using Oh My Zsh. Two other
+widgets exist, znt-cd-widget and znt-kill-widget, they can be too assigned
+to key combinations:
+
+    zle -N znt-cd-widget
+    bindkey "^T" znt-cd-widget
+    zle -N znt-kill-widget
+    bindkey "^Y" znt-kill-widget
+
+## Introduction
+
+The tools are:
+
+- n-aliases - browses aliases, relegates editing to vared
+- n-cd - browses dirstack and bookmarked directories, allows to enter selected directory
+- n-functions - browses functions, relegates editing to zed or vared
+- n-history - browses history, allows to edit and run commands from it
+- n-kill - browses processes list, allows to send signal to selected process
+- n-env - browses environment, relegates editing to vared
+- n-options - browses options, allows to toggle their state
+- n-panelize - loads output of given command into the list for browsing
+
+All tools support horizontal scroll with <,>, {,}, h,l or left and right
+cursors. Other keys are:
+
+- [,] - jump directory bookmarks in n-cd and typical signals in n-kill
+- Ctrl-d, Ctrl-u - half page up or down
+- Ctrl-p, Ctrl-n - previous and next (also done with vim's j,k)
+- Ctrl-l - redraw of whole display
+- g, G - beginning and end of the list
+- Ctrl-o, o - enter uniq mode (no duplicate lines)
+- / - start incremental search
+- Enter - finish incremental search, retaining filter
+- Esc - exit incremental search, clearing filter
+- Ctrl-w (in incremental search) - delete whole word
+- Ctrl-k (in incremental search) - delete whole line
+
+## Programming
+
+The function n-list is used as follows:
+
+    n-list {element1} [element2] ... [elementN]
+
+This is all that is needed to be done to have the features like ANSI coloring,
+incremental multi-word search, unique mode, horizontal scroll, non-selectable
+elements (grepping is done outside n-list, see the tools for how it can be
+done). To set up non-selectable entries add their indices into array
+NLIST_NONSELECTABLE_ELEMENTS:
+
+    typeset -a NLIST_NONSELECTABLE_ELEMENTS
+    NLIST_NONSELECTABLE_ELEMENTS=( 1 )
+
+Result is stored as $reply[REPLY] ($ isn't needed before REPLY because
+of arithmetic context inside []). The returned array might be different from
+input arguments as n-list can process them via incremental search or uniq
+mode. $REPLY is the index in that possibly processed array. If $REPLY
+equals -1 it means that no selection have been made (user quitted via q
+key).
+
+To set up entries that can be jumped to with [,] keys add their indices to
+NLIST_HOP_INDEXES array:
+
+    typeset -a NLIST_HOP_INDEXES
+    NLIST_HOP_INDEXES=( 1 10 )
+
+n-list can automatically colorize entries according to a Zsh pattern.
+Following example will colorize all numbers with blue:
+
+    local NLIST_COLORING_PATTERN="[0-9]##"
+    local NLIST_COLORING_COLOR=$'\x1b[00;34m'
+    local NLIST_COLORING_END_COLOR=$'\x1b[0m'
+    local NLIST_COLORING_MATCH_MULTIPLE=1
+    n-list "This is a number 123" "This line too has a number: 456"
+
+Blue is the default color, it doesn't have to be set. See zshexpn man page
+for more information on Zsh patterns. Briefly, comparing to regular
+expressions, (#s) is ^, (#e) is $, # is *, ## is +. Alternative
+will work when in parenthesis, i.e. (a|b). BTW by using this method you can
+colorize output of the tools, via their config files (check out e.g. n-cd.conf,
+it uses this).

+ 47 - 0
plugins/zsh-navigation-tools/n-aliases

@@ -0,0 +1,47 @@
+# Copy this file into /usr/share/zsh/site-functions/
+# and add 'autoload n-aliases` to .zshrc
+#
+# This function allows to choose an alias for edition with vared
+#
+# Uses n-list
+
+emulate -L zsh
+
+setopt extendedglob
+zmodload zsh/curses
+zmodload zsh/parameter
+
+local IFS="
+"
+
+unset NLIST_COLORING_PATTERN
+
+[ -f ~/.config/znt/n-list.conf ] && . ~/.config/znt/n-list.conf
+[ -f ~/.config/znt/n-aliases.conf ] && . ~/.config/znt/n-aliases.conf
+
+local list
+local selected
+
+NLIST_REMEMBER_STATE=0
+
+list=( "${(@k)aliases}" )
+list=( "${(@M)list:#(#i)*$1*}" )
+
+local NLIST_GREP_STRING="$1"
+
+if [ "$#list" -eq 0 ]; then
+    echo "No matching aliases"
+    return 1
+fi
+
+list=( "${(@i)list}" )
+n-list "$list[@]"
+
+if [ "$REPLY" -gt 0 ]; then
+    selected="$reply[REPLY]"
+    echo "Editing \`$selected':"
+    print -rs "vared aliases\\[$selected\\]"
+    vared aliases\[$selected\]
+fi
+
+# vim: set filetype=zsh:

+ 68 - 0
plugins/zsh-navigation-tools/n-cd

@@ -0,0 +1,68 @@
+# Copy this file into /usr/share/zsh/site-functions/
+# and add 'autoload n-cd` to .zshrc
+#
+# This function allows to choose a directory from pushd stack
+#
+# Uses n-list
+
+emulate -L zsh
+
+setopt extendedglob pushdignoredups
+
+zmodload zsh/curses
+local IFS="
+"
+
+# Unset before configuration is read
+unset NLIST_COLORING_PATTERN
+
+[ -f ~/.config/znt/n-list.conf ] && . ~/.config/znt/n-list.conf
+[ -f ~/.config/znt/n-cd.conf ] && . ~/.config/znt/n-cd.conf
+
+local list
+local selected
+
+NLIST_REMEMBER_STATE=0
+
+list=( `dirs -p` )
+list=( "${(@M)list:#(#i)*$1*}" )
+
+local NLIST_GREP_STRING="$1"
+
+[ "$#list" -eq 0 ] && echo "No matching directories"
+
+if [ "$#hotlist" -ge 1 ]; then
+    typeset -a NLIST_NONSELECTABLE_ELEMENTS NLIST_HOP_INDEXES
+    local tmp_list_size="$#list"
+    NLIST_NONSELECTABLE_ELEMENTS=( $(( tmp_list_size+1 )) $(( tmp_list_size+2 )) )
+    list=( "$list[@]" "" $'\x1b[00;31m'"Hotlist"$'\x1b[00;00m': "$hotlist[@]" )
+    (( tmp_list_size+=3 ))
+    local middle_hop=$(( (tmp_list_size+$#list) / 2 ))
+    [[ "$middle_hop" -eq $tmp_list_size || "$middle_hop" -eq $#list ]] && middle_hop=""
+    [ "$tmp_list_size" -eq $#list ] && tmp_list_size=""
+    NLIST_HOP_INDEXES=( 1 $tmp_list_size $middle_hop $#list )
+else
+    [ "$#list" -eq 0 ] && return 1
+fi
+
+n-list "${list[@]}"
+
+if [ "$REPLY" -gt 0 ]; then
+    selected="$reply[REPLY]"
+    selected="${selected/#\~/$HOME}"
+
+    (( NCD_DONT_PUSHD )) && setopt NO_AUTO_PUSHD
+    cd "$selected"
+    (( NCD_DONT_PUSHD )) && setopt AUTO_PUSHD
+
+    # ZLE?
+    if [ "${(t)CURSOR}" = "integer-local-special" ]; then
+        zle -M "You have selected $selected"
+    else
+        echo "You have selected $selected"
+    fi
+else
+    [ "${(t)CURSOR}" = "integer-local-special" ] && zle redisplay
+fi
+
+# vim: set filetype=zsh:

+ 47 - 0
plugins/zsh-navigation-tools/n-env

@@ -0,0 +1,47 @@
+# Copy this file into /usr/share/zsh/site-functions/
+# and add 'autoload n-env` to .zshrc
+#
+# This function allows to choose an environment variable
+# for edition with vared
+#
+# Uses n-list
+
+emulate -L zsh
+
+setopt extendedglob
+unsetopt equals
+zmodload zsh/curses
+
+local IFS="
+"
+
+[ -f ~/.config/znt/n-list.conf ] && . ~/.config/znt/n-list.conf
+[ -f ~/.config/znt/n-env.conf ] && . ~/.config/znt/n-env.conf
+
+local list
+local selected
+
+NLIST_REMEMBER_STATE=0
+
+list=( `env` )
+list=( "${(@M)list:#(#i)*$1*}" )
+
+local NLIST_GREP_STRING="$1"
+
+if [ "$#list" -eq 0 ]; then
+    echo "No matching variables"
+    return 1
+fi
+
+list=( "${(@i)list}" )
+n-list "$list[@]"
+
+if [ "$REPLY" -gt 0 ]; then
+    selected="$reply[REPLY]"
+    selected="${selected%%=*}"
+    echo "Editing \`$selected':"
+    print -rs "vared \"$selected\""
+    vared "$selected"
+fi
+
+# vim: set filetype=zsh:

+ 54 - 0
plugins/zsh-navigation-tools/n-functions

@@ -0,0 +1,54 @@
+# Copy this file into /usr/share/zsh/site-functions/
+# and add 'autoload n-functions` to .zshrc
+#
+# This function allows to choose a function for edition with vared
+#
+# Uses n-list
+
+emulate -L zsh
+
+setopt extendedglob
+zmodload zsh/curses
+zmodload zsh/parameter
+
+local IFS="
+"
+
+unset NLIST_COLORING_PATTERN
+
+[ -f ~/.config/znt/n-list.conf ] && . ~/.config/znt/n-list.conf
+[ -f ~/.config/znt/n-functions.conf ] && . ~/.config/znt/n-functions.conf
+
+local list
+local selected
+
+NLIST_REMEMBER_STATE=0
+
+list=( "${(@k)functions}" )
+list=( "${(@M)list:#(#i)*$1*}" )
+
+local NLIST_GREP_STRING="$1"
+
+if [ "$#list" -eq 0 ]; then
+    echo "No matching functions"
+    return 1
+fi
+
+list=( "${(@i)list}" )
+n-list "$list[@]"
+
+if [ "$REPLY" -gt 0 ]; then
+    selected="$reply[REPLY]"
+    if [ "$feditor" = "zed" ]; then
+        echo "Editing \`$selected' (ESC ZZ or Ctrl-x-w to finish):"
+        autoload zed
+        print -rs "zed -f -- \"$selected\""
+        zed -f -- "$selected"
+    else
+        echo "Editing \`$selected':"
+        print -rs "vared functions\\[$selected\\]"
+        vared functions\[$selected\]
+    fi
+fi
+
+# vim: set filetype=zsh:

+ 53 - 0
plugins/zsh-navigation-tools/n-history

@@ -0,0 +1,53 @@
+# Copy this file into /usr/share/zsh/site-functions/
+# and add 'autoload n-history` to .zshrc
+#
+# This function allows to browse Z shell's history and use the
+# entries
+#
+# Uses n-list
+
+emulate -L zsh
+
+setopt extendedglob
+zmodload zsh/curses
+
+local IFS="
+"
+
+unset NLIST_COLORING_PATTERN
+
+[ -f ~/.config/znt/n-list.conf ] && . ~/.config/znt/n-list.conf
+[ -f ~/.config/znt/n-history.conf ] && . ~/.config/znt/n-history.conf
+
+local list
+local selected
+
+NLIST_REMEMBER_STATE=0
+
+list=( `builtin history -rn 1` )
+list=( "${(@M)list:#(#i)*$1*}" )
+
+local NLIST_GREP_STRING="$1"
+
+if [ "$#list" -eq 0 ]; then
+    echo "No matching history entries"
+    return 1
+fi
+
+n-list "${list[@]}"
+
+if [ "$REPLY" -gt 0 ]; then
+    selected="$reply[REPLY]"
+    # ZLE?
+    if [ "${(t)CURSOR}" = "integer-local-special" ]; then
+        zle redisplay
+        zle kill-whole-line
+        zle -U "$selected"
+    else
+        print -zr "$selected"
+    fi
+else
+    [ "${(t)CURSOR}" = "integer-local-special" ] && zle redisplay
+fi
+
+# vim: set filetype=zsh:

+ 96 - 0
plugins/zsh-navigation-tools/n-kill

@@ -0,0 +1,96 @@
+# Copy this file into /usr/share/zsh/site-functions/
+# and add 'autoload n-kill` to .zshrc
+#
+# This function allows to choose a process and a signal to send to it
+#
+# Uses n-list
+
+emulate -L zsh
+
+setopt extendedglob
+zmodload zsh/curses
+
+local IFS="
+"
+
+[ -f ~/.config/znt/n-list.conf ] && . ~/.config/znt/n-list.conf
+[ -f ~/.config/znt/n-kill.conf ] && . ~/.config/znt/n-kill.conf
+
+typeset -A signals
+signals=(
+     1       "1  - HUP"
+     2       "2  - INT"
+     3       "3  - QUIT"
+     6       "6  - ABRT"
+     9       "9  - KILL"
+     14      "14 - ALRM"
+     15      "15 - TERM"
+     17      "17 - STOP"
+     19      "19 - CONT"
+)
+
+local list
+local selected
+local signal
+local -a signal_names
+local title
+
+NLIST_REMEMBER_STATE=0
+
+typeset -a NLIST_NONSELECTABLE_ELEMENTS
+NLIST_NONSELECTABLE_ELEMENTS=( 1 )
+
+type ps 2>/dev/null 1>&2 || { echo >&2 "Error: \`ps' not found"; return 1 }
+
+case "$(uname)" in
+    CYGWIN*) list=( `command ps -Wa` )  ;;
+    *) list=( `command ps -o pid,uid,command -A` ) ;;
+esac
+
+# Ask of PID
+title=$'\x1b[00;31m'"${list[1]}"$'\x1b[00;00m\0'
+shift list
+list=( "$title" "${(@M)list:#(#i)*$1*}" )
+
+local NLIST_GREP_STRING="$1"
+
+if [ "$#list" -eq 1 ]; then
+    echo "No matching processes"
+    return 1
+fi
+
+n-list "$list[@]"
+
+# Got answer? (could be Ctrl-C or 'q')
+if [ "$REPLY" -gt 0 ]; then
+    selected="$reply[REPLY]"
+    selected="${selected## #}"
+    pid="${selected%% *}"
+
+    # Now ask of signal
+    signal_names=( ${(vin)signals} )
+    typeset -a NLIST_HOP_INDEXES
+    NLIST_HOP_INDEXES=( 3 6 8 )
+    unset NLIST_COLORING_PATTERN
+    n-list $'\x1b[00;31mSelect signal:\x1b[00;00m' "$signal_names[@]"
+
+    if [ "$REPLY" -gt 0 ]; then
+        selected="$reply[REPLY]"
+        signal="${(k)signals[(r)$selected]}"
+
+        # ZLE?
+        if [ "${(t)CURSOR}" = "integer-local-special" ]; then
+            zle redisplay
+            zle kill-whole-line
+            zle -U "kill -$signal $pid"
+        else
+            print -zr "kill -$signal $pid"
+        fi
+    else
+        [ "${(t)CURSOR}" = "integer-local-special" ] && zle redisplay
+    fi
+else
+    [ "${(t)CURSOR}" = "integer-local-special" ] && zle redisplay
+fi
+
+# vim: set filetype=zsh:

+ 410 - 0
plugins/zsh-navigation-tools/n-list

@@ -0,0 +1,410 @@
+# $1, $2, ... - elements of the list
+# $NLIST_NONSELECTABLE_ELEMENTS - array of indexes (1-based) that cannot be selected
+# $REPLY is the output variable - contains index (1-based) or -1 when no selection
+#
+# Copy this file into /usr/share/zsh/site-functions/
+# and add 'autoload n-list` to .zshrc
+#
+# This function outputs a list of elements that can be
+# navigated with keyboard. Uses curses library
+
+emulate -LR zsh
+
+setopt typesetsilent extendedglob noshortloops
+
+_nlist_has_terminfo=0
+
+zmodload zsh/curses
+zmodload zsh/terminfo 2>/dev/null && _nlist_has_terminfo=1
+
+trap "REPLY=-2; reply=(); return" TERM INT QUIT
+trap "_nlist_exit" EXIT
+
+# Drawing and input
+autoload n-list-draw n-list-input
+
+# Cleanup before any exit
+_nlist_exit() {
+    setopt localoptions
+    setopt extendedglob
+
+    [[ "$REPLY" = -(#c0,1)[0-9]## ]] || REPLY="-1"
+    zcurses 2>/dev/null delwin inner
+    zcurses 2>/dev/null delwin main
+    zcurses 2>/dev/null refresh
+    zcurses end
+    _nlist_alternate_screen 0
+    _nlist_cursor_visibility 1
+    unset _nlist_has_terminfo
+}
+
+# Outputs a message in the bottom of the screen
+_nlist_status_msg() {
+    # -1 for border, -1 for 0-based indexing
+    zcurses move main $(( term_height - 1 - 1 )) 2
+    zcurses clear main eol
+    zcurses string main "$1"
+    #status_msg_strlen is localized in caller
+    status_msg_strlen=$#1
+}
+
+# Prefer tput, then module terminfo
+_nlist_cursor_visibility() {
+    if type tput 2>/dev/null 1>&2; then
+        [ "$1" = "1" ] && { tput cvvis; tput cnorm }
+        [ "$1" = "0" ] && tput civis
+    elif [ "$_nlist_has_terminfo" = "1" ]; then
+        [ "$1" = "1" ] && { [ -n $terminfo[cvvis] ] && echo -n $terminfo[cvvis];
+                           [ -n $terminfo[cnorm] ] && echo -n $terminfo[cnorm] }
+        [ "$1" = "0" ] && [ -n $terminfo[civis] ] && echo -n $terminfo[civis]
+    fi 
+}
+
+# Reason for this function is that on some systems
+# smcup and rmcup are not knowing why left empty
+_nlist_alternate_screen() {
+    [ "$_nlist_has_terminfo" -ne "1" ] && return
+    [[ "$1" = "1" && -n "$terminfo[smcup]" ]] && return
+    [[ "$1" = "0" && -n "$terminfo[rmcup]" ]] && return
+
+    case "$TERM" in
+        *rxvt*)
+            [ "$1" = "1" ] && echo -n $'\x1b7\x1b[?47h'
+            [ "$1" = "0" ] && echo -n $'\x1b[2J\x1b[?47l\x1b8'
+            ;;
+        *)
+            [ "$1" = "1" ] && echo -n $'\x1b[?1049h'
+            [ "$1" = "0" ] && echo -n $'\x1b[?1049l'
+            # just to remember two other that work: $'\x1b7\x1b[r\x1b[?47h', $'\x1b[?47l\x1b8'
+            ;;
+    esac
+}
+
+_nlist_compute_user_vars_difference() {
+        if [[ "${(t)NLIST_NONSELECTABLE_ELEMENTS}" != "array" &&
+                "${(t)NLIST_NONSELECTABLE_ELEMENTS}" != "array-local" ]]
+        then
+            last_element_difference=0
+            current_difference=0
+        else
+            last_element_difference=$#NLIST_NONSELECTABLE_ELEMENTS
+            current_difference=0
+            local idx
+            for idx in "${(n)NLIST_NONSELECTABLE_ELEMENTS[@]}"; do
+                [ "$idx" -le "$NLIST_CURRENT_IDX" ] && current_difference+=1 || break
+            done
+        fi
+}
+
+# List was processed, check if variables aren't off range
+_nlist_verify_vars() {
+    [ "$NLIST_CURRENT_IDX" -gt "$last_element" ] && NLIST_CURRENT_IDX="$last_element"
+    [[ "$NLIST_CURRENT_IDX" -eq 0 && "$last_element" -ne 0 ]] && NLIST_CURRENT_IDX=1
+    (( NLIST_FROM_WHAT_IDX_LIST_IS_SHOWN=0+((NLIST_CURRENT_IDX-1)/page_height)*page_height+1 ))
+}
+
+# Compute the variables which are shown to the user
+_nlist_setup_user_vars() {
+    if [ "$1" = "1" ]; then
+        # Basic values when there are no non-selectables
+        NLIST_USER_CURRENT_IDX="$NLIST_CURRENT_IDX"
+        NLIST_USER_LAST_ELEMENT="$last_element"
+    else
+        _nlist_compute_user_vars_difference
+        NLIST_USER_CURRENT_IDX=$(( NLIST_CURRENT_IDX - current_difference ))
+        NLIST_USER_LAST_ELEMENT=$(( last_element - last_element_difference ))
+    fi
+}
+
+_nlist_coloring_list_into_col_list() {
+    local col=$'\x1b[00;34m' reset=$'\x1b[0m'
+    [ -n "$NLIST_COLORING_COLOR" ] && col="$NLIST_COLORING_COLOR"
+    [ -n "$NLIST_COLORING_END_COLOR" ] && reset="$NLIST_COLORING_END_COLOR"
+
+    if [ "$NLIST_COLORING_MATCH_MULTIPLE" -eq 1 ]; then
+        col_list=( "${(@)list//(#mi)$~NLIST_COLORING_PATTERN/$col${MATCH}$reset}" )
+    else
+        col_list=( "${(@)list/(#mi)$~NLIST_COLORING_PATTERN/$col${MATCH}$reset}" )
+    fi
+}
+
+#
+# Main code
+#
+
+# Check if there is proper input
+if [ "$#" -lt 1 ]; then
+    echo "Usage: n-list element_1 ..."
+    return 1
+fi
+
+REPLY="-1"
+reply=()
+
+integer term_height="$LINES"
+integer term_width="$COLUMNS"
+if [[ "$term_height" -lt 1 || "$term_width" -lt 1 ]]; then
+    local stty_out=$( stty size )
+    term_height="${stty_out% *}"
+    term_width="${stty_out#* }"
+fi
+integer inner_height=term_height-3
+integer inner_width=term_width-3
+integer page_height=inner_height
+integer page_width=inner_width
+
+typeset -a list col_list disp_list
+integer last_element=$#
+local action
+local final_key
+integer selection
+integer last_element_difference=0
+integer current_difference=0
+local prev_search_buffer=""
+integer prev_uniq_mode=0
+integer prev_start_idx=-1
+
+# Ability to remember the list between calls
+if [[ -z "$NLIST_REMEMBER_STATE" || "$NLIST_REMEMBER_STATE" -eq 0 || "$NLIST_REMEMBER_STATE" -eq 2 ]]; then
+    NLIST_FROM_WHAT_IDX_LIST_IS_SHOWN=1
+    NLIST_CURRENT_IDX=1
+    NLIST_IS_SEARCH_MODE=0
+    NLIST_SEARCH_BUFFER=""
+    NLIST_TEXT_OFFSET=0
+    NLIST_IS_UNIQ_MODE=0
+
+    # Zero - because it isn't known, unless we
+    # confirm that first element is selectable
+    NLIST_USER_CURRENT_IDX=0
+    [[ ${NLIST_NONSELECTABLE_ELEMENTS[(r)1]} != 1 ]] && NLIST_USER_CURRENT_IDX=1
+    NLIST_USER_LAST_ELEMENT=$(( last_element - $#NLIST_NONSELECTABLE_ELEMENTS ))
+
+    # 2 is init once, then remember
+    [ "$NLIST_REMEMBER_STATE" -eq 2 ] && NLIST_REMEMBER_STATE=1
+fi
+
+if [ "$NLIST_START_IN_SEARCH_MODE" -eq 1 ]; then
+    NLIST_START_IN_SEARCH_MODE=0
+    NLIST_IS_SEARCH_MODE=1
+fi
+
+if [ "$NLIST_START_IN_UNIQ_MODE" -eq 1 ]; then
+    NLIST_START_IN_UNIQ_MODE=0
+    NLIST_IS_UNIQ_MODE=1
+fi
+
+_nlist_alternate_screen 1
+zcurses init
+zcurses delwin main 2>/dev/null
+zcurses delwin inner 2>/dev/null
+zcurses addwin main "$term_height" "$term_width" 0 0
+zcurses addwin inner "$inner_height" "$inner_width" 1 2
+zcurses bg main white/black
+zcurses bg inner white/black
+if [ "$NLIST_IS_SEARCH_MODE" -ne 1 ]; then
+    _nlist_cursor_visibility 0
+fi
+
+#
+# Listening for input
+#
+
+local key keypad
+
+# Clear input buffer
+zcurses timeout main 0
+zcurses input main key keypad
+zcurses timeout main -1
+key=""
+keypad=""
+
+list=( "$@" )
+last_element="$#list"
+
+integer is_colored=0
+if [[ -z "$NLIST_SEARCH_BUFFER" && -n "$NLIST_COLORING_PATTERN" ]]; then
+    is_colored=1
+    _nlist_coloring_list_into_col_list
+fi
+
+while (( 1 )); do
+    # Do searching (filtering with string)
+    if [ -n "$NLIST_SEARCH_BUFFER" ]; then
+        # Compute new list, col_list ?
+        if [[ "$NLIST_SEARCH_BUFFER" != "$prev_search_buffer" || "$NLIST_IS_UNIQ_MODE" -ne "$prev_uniq_mode" ]]; then
+            prev_search_buffer="$NLIST_SEARCH_BUFFER"
+            prev_uniq_mode="$NLIST_IS_UNIQ_MODE"
+            # regenerating list -> regenerating disp_list
+            prev_start_idx=-1
+
+            # Take all elements, including duplicates and non-selectables
+            typeset +U list
+            list=( "$@" )
+
+            # Remove non-selectable elements
+            [ "$#NLIST_NONSELECTABLE_ELEMENTS" -gt 0 ] && for i in "${(nO)NLIST_NONSELECTABLE_ELEMENTS[@]}"; do
+                list[$i]=()
+            done
+
+            # Remove duplicates
+            [ "$NLIST_IS_UNIQ_MODE" -eq 1 ] && typeset -U list
+
+            last_element="$#list"
+
+            # Next do the filtering
+            local search_buffer="${NLIST_SEARCH_BUFFER%% ##}"
+            search_buffer="${search_buffer## ##}"
+            search_buffer="${search_buffer//(#m)[][*?|#~^()><\\]/\\$MATCH}"
+            if [ -n "$search_buffer" ]; then
+                # Patterns will be *foo*~^*bar* and foo|bar)
+                local search_pattern="${search_buffer// ##/*~^*}"
+                local colsearch_pattern="${search_buffer// ##/|}"
+
+                list=( "${(@M)list:#(#i)*$~search_pattern*}" )
+                last_element="$#list"
+
+                local red=$'\x1b[00;31m' reset=$'\x1b[00;00m'
+                col_list=( "${(@)list//(#mi)($~colsearch_pattern)/$red${MATCH}$reset}" )
+            else
+                col_list=( "$list[@]" )
+            fi
+
+            # Called after processing list
+            _nlist_verify_vars
+        fi
+
+        _nlist_setup_user_vars 1
+
+        integer end_idx=$(( NLIST_FROM_WHAT_IDX_LIST_IS_SHOWN + page_height - 1 ))
+        [ "$end_idx" -gt "$last_element" ] && end_idx=last_element
+
+        if [ "$prev_start_idx" -ne "$NLIST_FROM_WHAT_IDX_LIST_IS_SHOWN" ]; then
+            prev_start_idx="$NLIST_FROM_WHAT_IDX_LIST_IS_SHOWN"
+            disp_list=( "${(@)col_list[NLIST_FROM_WHAT_IDX_LIST_IS_SHOWN, end_idx]}" )
+        fi
+
+        # Output colored list
+        n-list-draw "$(( (NLIST_CURRENT_IDX-1) % page_height + 1 ))" \
+            "$page_height" "$page_width" 0 0 "$NLIST_TEXT_OFFSET" inner \
+            "$disp_list[@]"
+    else
+        # There is no search, but there was in previous loop
+        # OR
+        # Uniq mode was entered or left out
+        # -> compute new list (maybe also col_list)
+        if [[ -n "$prev_search_buffer" || "$NLIST_IS_UNIQ_MODE" -ne "$prev_uniq_mode" ]]; then
+            prev_search_buffer=""
+            prev_uniq_mode="$NLIST_IS_UNIQ_MODE"
+            # regenerating list -> regenerating disp_list
+            prev_start_idx=-1
+
+            # Take all elements, including duplicates and non-selectables
+            typeset +U list
+            list=( "$@" )
+
+            # Remove non-selectable elements only when in uniq mode
+            [ "$NLIST_IS_UNIQ_MODE" -eq 1 ] && [ "$#NLIST_NONSELECTABLE_ELEMENTS" -gt 0 ] &&
+            for i in "${(nO)NLIST_NONSELECTABLE_ELEMENTS[@]}"; do
+                list[$i]=()
+            done
+
+            # Remove duplicates when in uniq mode
+            [ "$NLIST_IS_UNIQ_MODE" -eq 1 ] && typeset -U list
+
+            # Apply coloring pattern (when not with search query)
+            is_colored=0
+            if [ -n "$NLIST_COLORING_PATTERN" ]; then
+                is_colored=1
+                _nlist_coloring_list_into_col_list 
+            fi
+
+            last_element="$#list"
+            # Called after processing list
+            _nlist_verify_vars
+        fi
+
+        # "1" - shouldn't bother with non-selectables
+        _nlist_setup_user_vars "$NLIST_IS_UNIQ_MODE"
+
+        integer end_idx=$(( NLIST_FROM_WHAT_IDX_LIST_IS_SHOWN + page_height - 1 ))
+        [ "$end_idx" -gt "$last_element" ] && end_idx=last_element
+
+        if [ "$is_colored" -eq 0 ]; then
+            if [ "$prev_start_idx" -ne "$NLIST_FROM_WHAT_IDX_LIST_IS_SHOWN" ]; then
+                prev_start_idx="$NLIST_FROM_WHAT_IDX_LIST_IS_SHOWN"
+                disp_list=( "${(@)list[NLIST_FROM_WHAT_IDX_LIST_IS_SHOWN, end_idx]}" )
+            fi
+        else
+            if [ "$prev_start_idx" -ne "$NLIST_FROM_WHAT_IDX_LIST_IS_SHOWN" ]; then
+                prev_start_idx="$NLIST_FROM_WHAT_IDX_LIST_IS_SHOWN"
+                disp_list=( "${(@)col_list[NLIST_FROM_WHAT_IDX_LIST_IS_SHOWN, end_idx]}" )
+            fi
+        fi
+
+        # Output the list
+        n-list-draw "$(( (NLIST_CURRENT_IDX-1) % page_height + 1 ))" \
+            "$page_height" "$page_width" 0 0 "$NLIST_TEXT_OFFSET" inner \
+            "$disp_list[@]"
+    fi
+
+    local status_msg_strlen
+    if [ "$NLIST_IS_SEARCH_MODE" = "1" ]; then
+        local _txt2=""
+        [ "$NLIST_IS_UNIQ_MODE" -eq 1 ] && _txt2="[-UNIQ-] "
+        _nlist_status_msg "${_txt2}Filtering with: ${NLIST_SEARCH_BUFFER// /+}"
+    elif [[ ${NLIST_NONSELECTABLE_ELEMENTS[(r)$NLIST_CURRENT_IDX]} != $NLIST_CURRENT_IDX ||
+            -n "$NLIST_SEARCH_BUFFER" || "$NLIST_IS_UNIQ_MODE" -eq 1 ]]; then
+        local _txt="" _txt2=""
+        [ -n "$NLIST_GREP_STRING" ] && _txt=" [$NLIST_GREP_STRING]"
+        [ "$NLIST_IS_UNIQ_MODE" -eq 1 ] && _txt2="[-UNIQ-] "
+        _nlist_status_msg "${_txt2}Current #$NLIST_USER_CURRENT_IDX (of #$NLIST_USER_LAST_ELEMENT entries)$_txt"
+    else
+        _nlist_status_msg ""
+    fi
+
+    zcurses border main
+    zcurses refresh main inner
+    zcurses move main $(( term_height - 1 - 1 )) $(( status_msg_strlen + 2 ))
+
+    # Wait for input
+    zcurses input main key keypad
+
+    # Get the special (i.e. "keypad") key or regular key
+    if [ -n "$key" ]; then
+        final_key="$key" 
+    elif [ -n "$keypad" ]; then
+        final_key="$keypad"
+    else
+        _nlist_status_msg "Inproper input detected"
+        zcurses refresh main inner
+    fi
+
+    n-list-input "$NLIST_CURRENT_IDX" "$NLIST_FROM_WHAT_IDX_LIST_IS_SHOWN" \
+                    "$page_height" "$page_width" "$last_element" "$NLIST_TEXT_OFFSET" \
+                    "$final_key" "$NLIST_IS_SEARCH_MODE" "$NLIST_SEARCH_BUFFER" \
+                    "$NLIST_IS_UNIQ_MODE"
+
+    selection="$reply[1]"
+    action="$reply[2]"
+    NLIST_CURRENT_IDX="$reply[3]"
+    NLIST_FROM_WHAT_IDX_LIST_IS_SHOWN="$reply[4]"
+    NLIST_TEXT_OFFSET="$reply[5]"
+    NLIST_IS_SEARCH_MODE="$reply[6]"
+    NLIST_SEARCH_BUFFER="$reply[7]"
+    NLIST_IS_UNIQ_MODE="$reply[8]"
+
+    if [ "$action" = "SELECT" ]; then
+        REPLY="$selection"
+        reply=( "$list[@]" )
+        break
+    elif [ "$action" = "QUIT" ]; then
+        REPLY=-1
+        reply=( "$list[@]" )
+        break
+    elif [ "$action" = "REDRAW" ]; then
+        zcurses clear main redraw
+        zcurses clear inner redraw
+    fi
+done
+
+# vim: set filetype=zsh:

+ 131 - 0
plugins/zsh-navigation-tools/n-list-draw

@@ -0,0 +1,131 @@
+# Copy this file into /usr/share/zsh/site-functions/
+# and add 'autoload n-list-draw` to .zshrc
+#
+# This is an internal function not for direct use
+
+emulate -L zsh
+
+zmodload zsh/curses
+
+setopt typesetsilent extendedglob
+
+_nlist_print_with_ansi() {
+    local win="$1" text="$2" out col chunk Xout
+    integer text_offset="$3" max_text_len="$4" text_len=0 no_match=0 nochunk_text_len to_skip_from_chunk to_chop_off_from_chunk before_len
+
+    # 1 - non-escaped text, 2 - first number in the escaped text, with ;
+    # 3 - second number, 4 - text after whole escape text
+
+    typeset -a c
+    c=( black red green yellow blue magenta cyan white )
+
+    while [[ -n "$text" && "$no_match" -eq 0 ]]; do
+        if [[ "$text" = (#b)([^$'\x1b']#)$'\x1b'\[([0-9](#c0,2))(#B)(\;|)(#b)([0-9](#c0,2))m(*) ]]; then
+            # Text for further processing
+            text="$match[4]"
+            # Text chunk to output now
+            out="$match[1]"
+            # Save color
+            col="$match[2]"
+            (( match[3] >= 30 && match[3] <= 37 )) && col="$match[3]"
+        else
+            out="$text"
+            no_match=1
+        fi
+
+        if [ -n "$out" ]; then
+################ Expand tabs ################
+            chunk="$out"
+            before_len="$text_len"
+            Xout=""
+
+            while [ -n "$chunk" ]; do
+                [[ "$chunk" = (#b)([^$'\t']#)$'\t'(*) ]] && {
+                    (( all_text_len=((before_len+${#match[1]})/8+1)*8 ))
+
+                    Xout+="${(r:all_text_len-before_len:: :)match[1]}"
+
+                    before_len+=all_text_len-before_len
+                    chunk="$match[2]"
+                } || {
+                    Xout+="$chunk"
+                    break
+                }
+            done
+#############################################
+
+            # Input text length without the current chunk
+            nochunk_text_len=text_len
+            # Input text length up to current chunk
+            text_len+="$#Xout"
+
+            # Should start displaying with this chunk?
+            # I.e. stop skipping left part of the input text?
+            if (( text_len > text_offset )); then
+                to_skip_from_chunk=text_offset-nochunk_text_len
+
+                # LEFT - is chunk off the left skip boundary? +1 for 1-based index in string
+                (( to_skip_from_chunk > 0 )) && Xout="${Xout[to_skip_from_chunk+1,-1]}"
+
+                # RIGHT - is text off the screen?
+                if (( text_len-text_offset > max_text_len )); then
+                    to_chop_off_from_chunk=0+(text_len-text_offset)-max_text_len
+                    Xout="${Xout[1,-to_chop_off_from_chunk-1]}"
+                fi
+                
+                [ -n "$Xout" ] && zcurses string "$win" "$Xout"
+            fi
+        fi
+
+        if (( no_match == 0 )); then
+            if (( col >= 30 && col <= 37 )); then
+                zcurses attr "$win" $c[col-29]/black
+            elif [[ "$col" -eq 0 ]]; then
+                zcurses attr "$win" white/black
+            fi
+        fi
+    done
+}
+
+integer highlight="$1"
+integer page_height="$2"
+integer page_width="$3"
+local y_offset="$4"
+local x_offset="$5"
+local text_offset="$6"
+local win="$7"
+shift 7
+integer max_text_len=page_width-x_offset
+
+[ "$bold" = "0" ] && bold="" || bold="+bold"
+[[ "$active_text" = "underline" || "$active_text" = "reverse" ]] || active_text="reverse"
+# With Linux terminal underline won't work properly
+[ "$TERM" = "linux" ] && active_text="reverse"
+
+integer max_idx=page_height
+integer end_idx=max_idx
+[ "$end_idx" -gt "$#" ] && end_idx="$#"
+integer y=y_offset
+
+zcurses attr "$win" $bold white/black
+
+integer i text_len
+local text
+for (( i=1; i<=end_idx; i++ )); do
+    zcurses move "$win" $y "$x_offset"
+
+    [ "$i" = "$highlight" ] && zcurses attr "$win" +"$active_text"
+    _nlist_print_with_ansi "$win" "$@[i]" "$text_offset" "$max_text_len"
+    zcurses clear "$win" eol
+    [ "$i" = "$highlight" ] && zcurses attr "$win" -"$active_text"
+
+    y+=1
+done
+
+if [ "$end_idx" -lt "$max_idx" ]; then
+    zcurses move "$win" $y "$x_offset"
+    zcurses clear "$win" eol
+fi
+
+zcurses attr "$win" white/black
+# vim: set filetype=zsh:

+ 238 - 0
plugins/zsh-navigation-tools/n-list-input

@@ -0,0 +1,238 @@
+# Copy this file into /usr/share/zsh/site-functions/
+# and add 'autoload n-list-input` to .zshrc
+#
+# This is an internal function not for direct use
+
+emulate -L zsh
+
+zmodload zsh/curses
+
+setopt typesetsilent
+
+# Compute first to show index
+_nlist_compute_first_to_show_idx() {
+    from_what_idx_list_is_shown=0+((current_idx-1)/page_height)*page_height+1
+}
+
+typeset -ga reply
+reply=( -1 '' )
+integer current_idx="$1"
+integer from_what_idx_list_is_shown="$2"
+integer page_height="$3"
+integer page_width="$4"
+integer last_element="$5"
+integer hscroll="$6"
+local key="$7"
+integer search="$8"
+local buffer="$9"
+integer uniq_mode="$10"
+
+#
+# Listening for input
+#
+
+if [ "$search" = "0" ]; then
+
+case "$key" in
+    (UP|k|$'\C-P')
+        # Are there any elements before the current one?
+        [ "$current_idx" -gt 1 ] && current_idx=current_idx-1;
+        _nlist_compute_first_to_show_idx
+        ;;
+    (DOWN|j|$'\C-N')
+        # Are there any elements after the current one?
+        [ "$current_idx" -lt "$last_element" ] && current_idx=current_idx+1;
+        _nlist_compute_first_to_show_idx
+        ;;
+    (PPAGE)
+        current_idx=current_idx-page_height
+        [ "$current_idx" -lt 1 ] && current_idx=1;
+        _nlist_compute_first_to_show_idx
+        ;;
+    (NPAGE|" ")
+        current_idx=current_idx+page_height
+        [ "$current_idx" -gt "$last_element" ] && current_idx=last_element;
+        _nlist_compute_first_to_show_idx
+        ;;
+    ($'\C-U')
+        current_idx=current_idx-page_height/2
+        [ "$current_idx" -lt 1 ] && current_idx=1;
+        _nlist_compute_first_to_show_idx
+        ;;
+    ($'\C-D')
+        current_idx=current_idx+page_height/2
+        [ "$current_idx" -gt "$last_element" ] && current_idx=last_element;
+        _nlist_compute_first_to_show_idx
+        ;;
+    (HOME|g)
+        current_idx=1
+        _nlist_compute_first_to_show_idx
+        ;;
+    (END|G)
+        current_idx=last_element
+        _nlist_compute_first_to_show_idx
+        ;;
+    ($'\n')
+        # Is that element selectable?
+        # Check for this only when there is no search
+        if [[ "$NLIST_SEARCH_BUFFER" != "" || "$NLIST_IS_UNIQ_MODE" -eq 1 ||
+            ${NLIST_NONSELECTABLE_ELEMENTS[(r)$current_idx]} != $current_idx ]]
+        then
+            # Save current element in the result variable
+            reply=( $current_idx SELECT )
+        fi
+        ;;
+    (q)
+        reply=( -1 QUIT )
+        ;;
+    (/)
+        search=1
+        _nlist_cursor_visibility 1
+        ;;
+    ($'\t')
+        reply=( $current_idx LEAVE )
+        ;;
+    ($'\C-L')
+        reply=( -1 REDRAW )
+        ;;
+    (\])
+        [[ "${(t)NLIST_HOP_INDEXES}" = "array" || "${(t)NLIST_HOP_INDEXES}" = "array-local" ]] &&
+        [ -z "$NLIST_SEARCH_BUFFER" ] && [ "$NLIST_IS_UNIQ_MODE" -eq 0 ] &&
+        for idx in "${(n)NLIST_HOP_INDEXES[@]}"; do
+            if [ "$idx" -gt "$current_idx" ]; then
+                current_idx=$idx
+                _nlist_compute_first_to_show_idx
+                break
+            fi
+        done
+        ;;
+    (\[)
+        [[ "${(t)NLIST_HOP_INDEXES}" = "array" || "${(t)NLIST_HOP_INDEXES}" = "array-local" ]] &&
+        [ -z "$NLIST_SEARCH_BUFFER" ] && [ "$NLIST_IS_UNIQ_MODE" -eq 0 ] &&
+        for idx in "${(nO)NLIST_HOP_INDEXES[@]}"; do
+            if [ "$idx" -lt "$current_idx" ]; then
+                current_idx=$idx
+                _nlist_compute_first_to_show_idx
+                break
+            fi
+        done
+        ;;
+    ('<'|'{'|LEFT|'h')
+        hscroll=hscroll-7
+        [ "$hscroll" -lt 0 ] && hscroll=0
+        ;;
+    ('>'|'}'|RIGHT|'l')
+        hscroll+=7
+        ;;
+    ($'\E')
+        buffer=""
+        ;;
+    (o|$'\C-O')
+        uniq_mode=1-uniq_mode
+        ;;
+    (*)
+        ;;
+esac
+
+else
+
+case "$key" in
+    ($'\n')
+        search=0
+        _nlist_cursor_visibility 0
+        ;;
+    ($'\C-L')
+        reply=( -1 REDRAW )
+        ;;
+
+    #
+    # Slightly limited navigation
+    #
+
+    (UP|$'\C-P')
+        [ "$current_idx" -gt 1 ] && current_idx=current_idx-1;
+        _nlist_compute_first_to_show_idx
+        ;;
+    (DOWN|$'\C-N')
+        [ "$current_idx" -lt "$last_element" ] && current_idx=current_idx+1;
+        _nlist_compute_first_to_show_idx
+        ;;
+    (PPAGE)
+        current_idx=current_idx-page_height
+        [ "$current_idx" -lt 1 ] && current_idx=1;
+        _nlist_compute_first_to_show_idx
+        ;;
+    (NPAGE)
+        current_idx=current_idx+page_height
+        [ "$current_idx" -gt "$last_element" ] && current_idx=last_element;
+        _nlist_compute_first_to_show_idx
+        ;;
+    ($'\C-U')
+        current_idx=current_idx-page_height/2
+        [ "$current_idx" -lt 1 ] && current_idx=1;
+        _nlist_compute_first_to_show_idx
+        ;;
+    ($'\C-D')
+        current_idx=current_idx+page_height/2
+        [ "$current_idx" -gt "$last_element" ] && current_idx=last_element;
+        _nlist_compute_first_to_show_idx
+        ;;
+    (HOME)
+        current_idx=1
+        _nlist_compute_first_to_show_idx
+        ;;
+    (END)
+        current_idx=last_element
+        _nlist_compute_first_to_show_idx
+        ;;
+    (LEFT)
+        hscroll=hscroll-7
+        [ "$hscroll" -lt 0 ] && hscroll=0
+        ;;
+    (RIGHT)
+        hscroll+=7
+        ;;
+    (F1|F2|F3|F4|F5|F6|F7|F8|F9|F10)
+        # ignore
+        ;;
+
+    #
+    # The input
+    #
+
+    ($'\b'|$'\C-?'|BACKSPACE)
+        buffer="${buffer%?}"
+        ;;
+    ($'\C-W')
+        [ "$buffer" = "${buffer% *}" ] && buffer="" || buffer="${buffer% *}"
+        ;;
+    ($'\C-K')
+        buffer=""
+        ;;
+    ($'\E')
+        buffer=""
+        search=0
+        _nlist_cursor_visibility 0
+        ;;
+    ($'\C-O')
+        uniq_mode=1-uniq_mode
+        ;;
+    (*)
+        if [[ $#key == 1 && $((#key)) -lt 31 ]]; then
+            # ignore all other control keys
+        else
+            buffer+="$key"
+        fi
+        ;;
+esac
+
+fi
+
+reply[3]="$current_idx"
+reply[4]="$from_what_idx_list_is_shown"
+reply[5]="$hscroll"
+reply[6]="$search"
+reply[7]="$buffer"
+reply[8]="$uniq_mode"
+
+# vim: set filetype=zsh:

+ 84 - 0
plugins/zsh-navigation-tools/n-options

@@ -0,0 +1,84 @@
+# Copy this file into /usr/share/zsh/site-functions/
+# and add 'autoload n-options` to .zshrc
+#
+# This function allows to browse and toggle shell's options
+#
+# Uses n-list
+
+#emulate -L zsh
+
+zmodload zsh/curses
+
+local IFS="
+"
+
+unset NLIST_COLORING_PATTERN
+
+[ -f ~/.config/znt/n-list.conf ] && . ~/.config/znt/n-list.conf
+[ -f ~/.config/znt/n-options.conf ] && . ~/.config/znt/n-options.conf
+
+# TODO restore options
+unsetopt localoptions
+
+integer kshoptionprint=0
+[[ -o kshoptionprint ]] && kshoptionprint=1
+setopt kshoptionprint
+
+local list
+local selected
+local option
+local state
+
+# 0 - don't remember, 1 - remember, 2 - init once, then remember
+NLIST_REMEMBER_STATE=2
+
+local NLIST_GREP_STRING="${1:=}"
+
+while (( 1 )); do
+    list=( `setopt` )
+    list=( "${(M)list[@]:#*${1:=}*}" )
+    list=( "${list[@]:#kshoptionprint*}" )
+
+    if [ "$#list" -eq 0 ]; then
+        echo "No matching options"
+        break
+    fi
+
+    local red=$'\x1b[00;31m' green=$'\x1b[00;32m' reset=$'\x1b[00;00m'
+    list=( "${list[@]/ off/${red} off$reset}" )
+    #list=( "${list[@]/ on/${green} on$reset}" )
+    list=( "${(i)list[@]}" )
+
+    n-list "${list[@]}"
+
+    if [ "$REPLY" -gt 0 ]; then
+        [[ -o ksharrays ]] && selected="${reply[$(( REPLY - 1 ))]}" || selected="${reply[$REPLY]}"
+        option="${selected%% *}"
+        state="${selected##* }"
+
+        if [[ -o globsubst ]]; then
+            unsetopt globsubst
+            state="${state%$reset}"
+            setopt globsubst
+        else
+            state="${state%$reset}"
+        fi
+
+        # Toggle the option
+        if [ "$state" = "on" ]; then
+            echo "Setting |$option| to off"
+            unsetopt "$option"
+        else
+            echo "Setting |$option| to on"
+            setopt "$option"
+        fi
+    else
+        break
+    fi
+done
+
+NLIST_REMEMBER_STATE=0
+
+[[ "$kshoptionprint" -eq 0 ]] && unsetopt kshoptionprint
+
+# vim: set filetype=zsh:

+ 61 - 0
plugins/zsh-navigation-tools/n-panelize

@@ -0,0 +1,61 @@
+# Copy this file into /usr/share/zsh/site-functions/
+# and add 'autoload n-panelize` to .zshrc
+#
+# This function somewhat reminds the panelize feature from Midnight Commander
+# It allows browsing output of arbitrary command. Example usage:
+# v-panelize ls /usr/local/bin
+#
+# Uses n-list
+
+emulate -L zsh
+
+setopt extendedglob
+zmodload zsh/curses
+
+local IFS="
+"
+
+unset NLIST_COLORING_PATTERN
+
+[ -f ~/.config/znt/n-list.conf ] && . ~/.config/znt/n-list.conf
+[ -f ~/.config/znt/n-panelize.conf ] && . ~/.config/znt/n-panelize.conf
+
+local list
+local selected
+
+NLIST_REMEMBER_STATE=0
+
+if [ -t 0 ]; then
+    # Check if there is proper input
+    if [ "$#" -lt 1 ]; then
+        echo "Usage: n-panelize {command} [option|argument] ... or command | n-panelize"
+        return 1
+    fi
+
+    list=( `"$@"` )
+    # TODO: $? doesn't reach user
+    [ "$?" -eq 127 ] && return $?
+else
+    # Check if can reattach to terminal
+    if [[ ! -c /dev/tty && ! -t 2 ]]; then
+        echo "No terminal available (no /dev/tty)"
+        return 1
+    fi
+
+    list=( "${(@f)"$(<&0)"}" )
+
+    if [[ ! -c /dev/tty ]]; then
+        exec <&2
+    else
+        exec </dev/tty
+    fi
+fi
+
+n-list "${list[@]}"
+
+if [ "$REPLY" -gt 0 ]; then
+    selected="$reply[REPLY]"
+    print -zr "# $selected"
+fi
+
+# vim: set filetype=zsh:

+ 8 - 0
plugins/zsh-navigation-tools/znt-cd-widget

@@ -0,0 +1,8 @@
+autoload znt-usetty-wrapper n-cd
+local NLIST_START_IN_SEARCH_MODE=0
+local NLIST_START_IN_UNIQ_MODE=0
+
+znt-usetty-wrapper n-cd "$@"
+
+unset NLIST_START_IN_SEARCH_MODE
+unset NLIST_START_IN_UNIQ_MODE

+ 8 - 0
plugins/zsh-navigation-tools/znt-history-widget

@@ -0,0 +1,8 @@
+autoload znt-usetty-wrapper n-history
+local NLIST_START_IN_SEARCH_MODE=1
+local NLIST_START_IN_UNIQ_MODE=1
+
+znt-usetty-wrapper n-history "$@"
+
+unset NLIST_START_IN_SEARCH_MODE
+unset NLIST_START_IN_UNIQ_MODE

+ 8 - 0
plugins/zsh-navigation-tools/znt-kill-widget

@@ -0,0 +1,8 @@
+autoload znt-usetty-wrapper n-kill
+local NLIST_START_IN_SEARCH_MODE=0
+local NLIST_START_IN_UNIQ_MODE=0
+
+znt-usetty-wrapper n-kill "$@"
+
+unset NLIST_START_IN_SEARCH_MODE
+unset NLIST_START_IN_UNIQ_MODE

+ 40 - 0
plugins/zsh-navigation-tools/znt-usetty-wrapper

@@ -0,0 +1,40 @@
+emulate -L zsh
+
+zmodload zsh/curses
+
+test_fd0() {
+    true <&0
+}
+
+local restore=0 FD
+
+# Reattach to terminal
+if [ ! -t 0 ]; then
+    # Check if can reattach to terminal in any way
+    if [[ ! -c /dev/tty && ! -t 2 ]]; then
+        echo "No terminal available (no /dev/tty and no terminal at stderr)"
+        return 1
+    fi
+
+    if test_fd0 2>/dev/null; then
+        exec {FD}<&0
+        restore=2
+    else
+        restore=1
+    fi
+
+    if [[ ! -c /dev/tty ]]; then
+        exec <&2
+    else
+        exec </dev/tty
+    fi
+fi
+
+# Run the command
+"$@"
+
+# Restore FD state
+(( restore == 1 )) && exec <&-
+(( restore == 2 )) && exec <&$FD && exec {FD}<&-
+
+# vim: set filetype=zsh:

+ 38 - 0
plugins/zsh-navigation-tools/zsh-navigation-tools.plugin.zsh

@@ -0,0 +1,38 @@
+#!/usr/bin/env zsh
+
+REPO_DIR="${0%/*}"
+CONFIG_DIR="$HOME/.config/znt"
+
+#
+# Copy configs
+#
+
+if ! test -d "$HOME/.config"; then
+    mkdir "$HOME/.config"
+fi
+
+if ! test -d "$CONFIG_DIR"; then
+    mkdir "$CONFIG_DIR"
+fi
+
+set n-aliases.conf n-env.conf n-history.conf n-list.conf n-panelize.conf n-cd.conf n-functions.conf n-kill.conf n-options.conf
+
+for i; do
+    if ! test -f "$CONFIG_DIR/$i"; then
+        cp "$REPO_DIR/.config/znt/$i" "$CONFIG_DIR"
+    fi
+done
+
+#
+# Load functions
+#
+
+autoload n-aliases n-cd n-env n-functions n-history n-kill n-list n-list-draw n-list-input n-options n-panelize
+autoload znt-usetty-wrapper znt-history-widget znt-cd-widget znt-kill-widget
+alias naliases=n-aliases ncd=n-cd nenv=n-env nfunctions=n-functions nhistory=n-history
+alias nkill=n-kill noptions=n-options npanelize=n-panelize
+
+zle -N znt-history-widget
+bindkey '^R' znt-history-widget
+setopt AUTO_PUSHD HIST_IGNORE_DUPS PUSHD_IGNORE_DUPS
+